package evenements.classes;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.Random;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingWorker;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * La partie vnements.
 * @author jub
 * Jeu du Tte  claque. 
 * Une vitesse, une cible sont choisies et sur clic du bouton start, 
 * le joueur doit clicker sur l'un des trois boutons qui contient l'image cible pour augmenter son temps.
 * A la fin du temps la partie s'arrte. 
 * Vous n'avez qu'a grer les vnements.    
 */
public class Evenements extends JFrame{
	/**
	 * Le label qui permet d'afficher le score.
	 */
	private JLabel labelScore;
	/**
	 * Le bouton de gauche qui affiche une image.
	 */
	private JButton buttonG;
	/**
	 * Le bouton du centre qui affiche une image.
	 */
	private JButton buttonC;
	/**
	 * Le bouton de droite qui affiche une image.
	 */
	private JButton buttonD;
	/**
	 * Le label qui contient l'image cible.
	 */
	private JLabel labelCible;
	/**
	 * La bare de progression du temps.
	 */
	private JProgressBar bar;
	/**
	 * Le slider qui permet de choisir la vitesse du jeux.
	 */
	private JSlider sliderVitesse;
	/**
	 * Le label qui permet d'afficher la vitesse choisie.
	 */
	private JLabel labelVitesse;
	/**
	 * Le spinner qui permet de choisir la cible.
	 */
	private JSpinner spinnerCible;
	/**
	 * Le bouton qui permet de lancer le jeu.
	 */
	private JButton buttonStart;

	/**
	 * Un tableau d'images utilis pour les cibles
	 */
	private ImageIcon[] images;
	/**
	 * L'image de fond des cartes
	 */
	private ImageIcon fond;

	/**
	 * Le score du modle.
	 */
	private int score;
	
	/**
	 * La vitesse du modle.
	 */
	private int vitesse;
	/**
	 * La cible choisie du modle.
	 */
	private int cible;

	/**
	 * Un SwingWorker pour animer le temps.
	 */
	private PasseLeTemps passeLeTemps;

	/**
	 * Construit une fentre de jeu avec un titre.
	 * @param titre le titre de la fentre.
	 */
	public Evenements(String titre){
		super(titre);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));

		this.images = new ImageIcon[10];
		URL url;
		for (int i=0; i <10; i++)
		{
			url = this.getClass().getClassLoader().getResource("evenements/ressources/tux"+i+".png");
			images[i] = new ImageIcon(url);
		}	
		url = this.getClass().getClassLoader().getResource("evenements/ressources/fond.png");
		this.fond = new ImageIcon(url);

		JPanel panel = new JPanel(new FlowLayout());
		JPanel panel2 = new JPanel(new FlowLayout());
		JPanel panel3 = new JPanel(new FlowLayout());

		labelScore = new JLabel();
		buttonG = new JButton();
		buttonC = new JButton();
		buttonD = new JButton();
		labelCible = new JLabel();
		bar = new JProgressBar();
		this.spinnerCible = new JSpinner();
		this.buttonStart = new JButton("Start");
		this.sliderVitesse = new JSlider(1,10);
		this.labelVitesse = new JLabel();


		this.init();
		panel.add(new JLabel("Score : "));
		panel.add(labelScore);

		panel2.add(this.buttonG);
		panel2.add(this.buttonC);
		panel2.add(this.buttonD);
		panel2.add(this.labelCible);
		panel2.add(this.sliderVitesse);

		panel3.add(new JLabel("Vitesse :"));
		panel3.add(this.sliderVitesse);
		panel3.add(this.labelVitesse);

		this.add(panel);
		this.add(panel2);
		this.add(this.bar);
		this.add(this.spinnerCible);
		this.add(panel3);
		this.add(this.buttonStart);
//Ajouter aprs vos couteurs
		
		
		
		
		
		
		
		
		
//Ajouter avant vos couteurs		
		this.pack();
		this.setResizable(false);
		this.setVisible(true);
	}

	//Ajouter vos classes internes aprs
	
	
	
	
	
	
	
	//Ajouter vos classes internes avant
	/**
	 * Permet d'initialiser le jeu.
	 * Vous n'avez pas  modifier le code.
	 */
	private void init()
	{
		reinit();
		labelCible.setIcon(this.images[this.cible]);
		SpinnerNumberModel model = new SpinnerNumberModel(this.cible,0,images.length-1,1);
		this.spinnerCible.setModel(model);
		this.vitesse = 1;
		this.sliderVitesse.setValue(this.vitesse);
		this.labelVitesse.setText(String.valueOf(this.vitesse));

	}

	/**
	 * Permet de rinitialiser le jeu pour une nouvelle partie.
	 * Vous n'avez pas  rinitialiser le code.
	 */
	private void reinit()
	{
		this.passeLeTemps = new PasseLeTemps();
		this.score = 0;
		this.labelScore.setText(String.valueOf(this.score));
		this.bar.setValue(0);
		buttonStart.setEnabled(true);
		sliderVitesse.setEnabled(true);
		spinnerCible.setEnabled(true);
		
		buttonG.setEnabled(false);
		buttonC.setEnabled(false);
		buttonD.setEnabled(false);
		this.buttonG.setIcon(this.fond);
		this.buttonC.setIcon(this.fond);
		this.buttonD.setIcon(this.fond);
		
	}
	/**
	 * Permet de modifier les images des boutons.
	 * Vous n'avez pas  modifier ce code.
	 */
	private void changeCard()
	{
		Random random = new Random();
		int[] num = new int[3];
		do
			num[0] = random.nextInt(images.length);
		while (num[0] == this.cible);
		do
			num[1] = random.nextInt(images.length);
		while (num[1] == this.cible);
		do
			num[2] = random.nextInt(images.length);
		while (num[2] == this.cible);
		num[random.nextInt(3)]=this.cible;
		buttonG.setIcon(images[num[0]]);
		buttonC.setIcon(images[num[1]]);
		buttonD.setIcon(images[num[2]]);

	}

	
	
	/**
	 * @author jub
	 * La classe qui permet la progression du temps.
	 * Vous n'avez pas  modifier le code.
	 */
	private class PasseLeTemps extends SwingWorker<Void, Void>
	{

		/* (non-Javadoc)
		 * @see javax.swing.SwingWorker#doInBackground()
		 */
		@Override
		protected Void doInBackground() throws Exception {
			while(bar.getValue()<100 && !isCancelled())
			{
				//attente
				Thread.sleep((10-sliderVitesse.getValue())*100);
				//mise  jour de la barre de progression
				bar.setValue(bar.getValue()+sliderVitesse.getValue());
				changeCard();
			}
			return null;
		}

		@Override
		protected void done() {
			// TODO Auto-generated method stub
			super.done();
			//Si nous n'avons pas t annul, nous avons perdu
			if (!this.isCancelled())
			{
				JOptionPane.showMessageDialog(Evenements.this, "score final : "+(score*vitesse));
				Evenements.this.reinit();
			}

		}


	}
	
}
